#include <bits/stdc++.h>

using namespace std;

#define endl			'\n'

int n, k, q;
int seed;
vector< int > v;

int minA, maxA;

int answer;

template<typename T>
string to_str(const T& n) {
	ostringstream ss;
	ss << n;
	return ss.str();
}

bool in(int x, int l, int r) {
	return (l <= x && x <= r);
}

int randNumber(int l, int r) {
	int x = ((rand() << 16) + rand()) % (r - l + 1) + l;
	return x;
}

vector<int> randVector(int n, int l, int r) {
	vector<int> v(n);
	for (int i = 0; i < n; i ++) {
		int x = randNumber(l, r);
		v[i] = x;
	}
	sort(v.begin(), v.end());
	return v;
}

void stop(int ok, string s) {
	ofstream out("output.txt");
	out << ok << endl;
	out << s << endl;
	out.close();
	exit(0);
}

string info(int n, int k, int q, int cnt) {
	return 	//"n = " + to_str(n) + ", " +
			//"k = " + to_str(k) + ", " +
			"n mod k = " + to_str(n % k) + "/" + to_str(k) + ", " +
			"q = " + to_str(cnt) + "/" + to_str(q);
}

string infoWA(int n, int k, int q, int cnt, int answer, int ans) {
	return 	"Expected " + to_str(answer) + ", " +
			"found " + to_str(ans) + ". " +
			info(n, k, q, cnt);
}

string infoOK(int n, int k, int q, int cnt, int answer) {
	return 	"Answer = " + to_str(answer) + ", " +
			info(n, k, q, cnt);
}

int dp[111111][111];
int p1[111111][111];
int p2[111111][111];

int solve(int n, int k, vector< int >& v) {
	if (n <= k)
		return 0;
	int d1 = n / k;
	int d2 = d1 + 1;
	int m2 = n % k;
	int m1 = k - m2;
	if (n % k == 0) {
		int ans = 0;
		for (int i = 0; i < n; i += d1) {
			ans += abs(v[i] - v[i + d1 - 1]);
		}
		return ans;
	}
	for (int i = 0; i <= n; i ++) {
		for (int j = 0; j <= k; j ++) {
			dp[i][j] = 1e9;
		}
	}
	dp[0][0] = 0;
	p1[0][0] = m1;
	p2[0][0] = m2;
	for (int i = 0; i < n; i ++) {
		for (int j = 0; j < k; j ++) {
			if (dp[i][j] == 1e9)
				continue;
			if (i + d1 <= n && p1[i][j]) {
				dp[i+d1][j+1] = min(dp[i+d1][j+1], dp[i][j] + abs(v[i] - v[i + d1 - 1]));
				p1[i+d1][j+1] = p1[i][j] - 1;
				p2[i+d1][j+1] = p2[i][j];
			}
			if (i + d2 <= n && p2[i][j]) {
				dp[i+d2][j+1] = min(dp[i+d2][j+1], dp[i][j] + abs(v[i] - v[i + d2 - 1]));
				p1[i+d2][j+1] = p1[i][j];
				p2[i+d2][j+1] = p2[i][j] - 1;
			}
		}
	}
	return dp[n][k];
}

void readTest() {
	fstream test("input.txt");
	test >> n >> k >> q >> seed;
	if (seed) {
		test >> minA >> maxA;
		return;
	}
	for (int i = 0; i < n; i ++) {
		int x;
		test >> x;
		v.push_back(x);
	}
}

void genTest() {
	if (seed) {
		srand(seed);
		v = randVector(n, minA, maxA);
	}
	answer = solve(n, k, v);
}

string cut(string& s, int idx) {
	return "\"" + s.substr(idx, min((int) s.length() - idx, 25)) + "\"";
}

bool isEof(string& s, int& idx) {
	return (idx >= s.size());
}

void checkEof(string& s, int& idx, string func) {
	if (isEof(s, idx)) {
		stop(2, "Expected data, but string ended: " + cut(s, max(0, idx - 15)) + " func: " + func);
	}
}

char readChar(string& s, int& idx) {
	checkEof(s, idx, "readChar()");
	return s[idx++];
}

bool readSpaces(string& s, int& idx, bool stopIfError = true) {
	if (stopIfError)
		checkEof(s, idx, "readSpaces()");
	if (s[idx] != ' ') {
		if (stopIfError)
			stop(2, "Expected space: " + cut(s, max(0, idx - 5)));
		return false;
	}
	while (!isEof(s, idx) && s[idx] == ' ') {
		++idx;
	}
	return true;
}

long long readLongLong(string& s, int& idx) {
	long long res = 0;
	checkEof(s, idx, "readInt()");
	if (!isdigit(s[idx])) {
		stop(2, "Expected number: " + cut(s, max(0, idx - 5)));
	}
	while (!isEof(s, idx) && isdigit(s[idx])) {
		res = res * 10 + (s[idx] - '0');
		++idx;
	}
	return res;
}

long long read(string& s, int& idx, string name, long long l, long long r, int error = 2) {
	long long res = readLongLong(s, idx);
	if (res < l || res > r) {
		stop(error, "Expected " + name + " in range [" + to_str(l) + "; " + to_str(r) + "], found " + to_str(res));
	}
	return res;
}

int main(int argc, char *argv[]) {
	readTest();
	genTest();

	cout << n << " " << k << endl;
	cout.flush();

	int cnt = 0;
	int cntEmpty = 0;
	while (true) {
		string s;
		int idx = 0;
		getline(cin, s);
		if (isEof(s, idx)) { /* empty line */
			++ cntEmpty;
			if (cntEmpty > 1e6)
				stop(2, "Empty stdin.");
			continue;
		}
		if (s.size() > 100) {
			stop(2, "Very long line: " + cut(s, 0));
		}

		char c = readChar(s, idx);
		readSpaces(s, idx);

		if (c == '?') {
			cnt ++;
			if (cnt > q)
				stop(1, "Too many requests. " + info(n, k, q, cnt));

			int i = read(s, idx, "i", 1, n);
			readSpaces(s, idx);
			int j = read(s, idx, "j", 1, n);
			readSpaces(s, idx, false);

			if (!isEof(s, idx)) {
				stop(2, "Extra information after answer: " + cut(s, idx - 1));
			}

			cout << abs(v[i-1] - v[j-1]) << endl;
			cout.flush();
		} else if (c == '!') {
			int ans = read(s, idx, "ans", 0, 2e9);
			readSpaces(s, idx, false);

			if (!isEof(s, idx)) {
				stop(2, "Extra information after answer: " + cut(s, idx - 1));
			}

			if (ans == answer) {
				cout << "ok" << endl;
				cout.flush();
				stop(0, "Ok. " + infoOK(n, k, q, cnt, answer));
			} else {
				cout << "You are bottom." << endl;
				cout.flush();
				stop(1, "Wrong Answer. " + infoWA(n, k, q, cnt, answer, ans));
			}
		} else if (s[idx] != '?') {
			stop(2, "Expected Request.");
		}
	}
	return 0;
}
